""" The infrastructure for registered mixin classes """

_mixin_registry = {}


def mixin_base(name, mixintype):
    _mixin_registry.setdefault(mixintype, {})

    def _dec(cls):
        _mixin_registry[mixintype][name] = cls
        return cls
    
    return _dec


def geometry_mixin(name):
    return mixin_base(name, "geometry")


def construct_from_mixins(base=object, mixins=[], mixintype="geometry", name="GeometryInterface"):
    mixins = tuple(_mixin_registry[mixintype][m] for m in mixins)
    return type(name, mixins + (base,), {})
